#ifndef _INTERPOLATION_H_
#define _INTERPOLATION_H_

void horner(double y,double* b,double* x,int n,double *z)
// Berechnet fuer  z=p(y)=b_0+(y-x_0)*(b_1+(y-x_1)*(b_2...))
// in der Newtonschen Basisdarstellung
// mittels Hornerschema
// Input: x=(0,...,0) entspr. kanonischer Basis
{
  int i;
  double u;
  *z=b[n-1];
  u=*z;
  for (i=n-2;i>=0;i--)
    { 
      *z=(*z)*(y-x[i])+b[i];
    }
}

void AitkenNeville(int n,double* x,double* y,double* u)
// Dividierte Differenzen mit Aitken-Neville
// Input: Stuetzstellen x_i mit werten y_i
// Output: u: mit p(t)=u_0+(t-x_0)(u_1+(t_x_1(u_2...))
{
  int i,k;
  vdcopy(n,u,1,y,1);
  for (k=1;k<n;k++)
    {
      for (i=n-1;i>=k;i--)
	{
	  u[i]=(u[i]-u[i-1])/(x[i]-x[i-k]);
	}
    }
}

#endif
